#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <unistd.h>

int create_socket(int *, int, int);

int *descriptor;

int main(int argc, char **argv) {
	int i, port, clients, connection;
	int	LV2S_i_BL, LV2S_i_IL, S2I_i_IL;
	float	LV2S_f_BL, LV2S_f_IL, S2I_f_IL;
	double	LV2S_d_BL, LV2S_d_IL, S2I_d_IL;

/*
 *	Parse command line arguments and create a socket
 *
 */

	for (i=1;i<argc - 1;i++) {
		if (strcmp(*(argv+i),"-p") == 0) {	// Port switch
			i++;
			port = atoi(*(argv + i));	// Set port to the command line argument
		}
		if (strcmp(*(argv+i),"-c") == 0) {	// Clients switch
			i++;
			clients = atoi(*(argv + i));	// Set number of concurrent clients to the command line argument
		}
	}

	if (!port || !clients) {
		printf("Usage: %s -p port -c clients\n\n",*argv);
		printf("\t-p port\t\tport to listen for incomming clients\n");
		printf("\t-c clients\tmaximum number of concurrent clients\n");
		exit(0);
	}

	descriptor = (int *) malloc(clients * sizeof(int));
	if (create_socket(descriptor, port, clients) <= 0) {
		printf("Error: Unable to create socket\n");
		exit(0);
	}

/*
 *	Arguments Parsed, Socket Created, Code Continues...
 *
 */
	read(*(descriptor+0), (char *) &LV2S_i_BL, sizeof(int));
	read(*(descriptor+0), (char *) &LV2S_f_BL, sizeof(float));
	read(*(descriptor+0), (char *) &LV2S_d_BL, sizeof(double));
	printf("%d\t%f\t%f\n", LV2S_i_BL, LV2S_f_BL, LV2S_d_BL);

	do {
		/* Read values from Labview */
		read(*(descriptor+0), (char *) &LV2S_i_IL, sizeof(int));
		read(*(descriptor+0), (char *) &LV2S_f_IL, sizeof(float));
		read(*(descriptor+0), (char *) &LV2S_d_IL, sizeof(double));

		/* Perform computations with values from Labview */
		S2I_i_IL = LV2S_i_BL + LV2S_i_IL;
		S2I_f_IL = LV2S_f_BL + LV2S_f_IL;
		S2I_d_IL = LV2S_d_BL + LV2S_d_IL;
		printf("%d\t%f\t%f\n", LV2S_i_IL, LV2S_f_IL, LV2S_d_IL);

		/* Send computed values to Inventor */
		write(*(descriptor+1), (char *) &S2I_i_IL, sizeof(int));
		write(*(descriptor+1), (char *) &S2I_f_IL, sizeof(float));
		write(*(descriptor+1), (char *) &S2I_d_IL, sizeof(double));
		printf("%d\t%f\t%f\n\n", S2I_i_IL, S2I_f_IL, S2I_d_IL);

		/* Send something to Labview */
		write(*(descriptor+0), (char *) &S2I_i_IL, sizeof(int));

		/* Check if Labview has disconnected, send to Inventor */
		read( *(descriptor+0), (char *) &connection, sizeof(int));
		write(*(descriptor+1), (char *) &connection, sizeof(int));
		read(*(descriptor+1), (char *) &connection, sizeof(int));
	} while (connection);

	for (i=0;i<clients;i++) close(*(descriptor+i));

	return 0;
}
